Package: ggdendro
Authors@R: c(person("Andrie", "de Vries", role=c("aut", "cre"),
    email="apdevries@gmail.com"), person(c("Brian", "D."), "Ripley", role =
    c("aut"), comment = "author of package tree"))
License: GPL-2 | GPL-3
Title: Create Dendrograms and Tree Diagrams Using 'ggplot2'
LazyData: true
LazyLoad: true
ByteCompile: true
Description: This is a set of tools for dendrograms and
    tree plots using 'ggplot2'.  The 'ggplot2' philosophy is to
    clearly separate data from the presentation.
    Unfortunately the plot method for dendrograms plots
    directly to a plot device without exposing the data.
    The 'ggdendro' package resolves this by making available
    functions that extract the dendrogram plot data. The package
    provides implementations for tree, rpart, as well as diana and agnes
    cluster diagrams.
Version: 0.1-20
URL: https://github.com/andrie/ggdendro
BugReports: https://github.com/andrie/ggdendro/issues
Date: 2016-04-27
Imports: MASS, ggplot2(>= 0.9.2)
Suggests: rpart(>= 4.0-0), tree, testthat, knitr, cluster, scales
VignetteBuilder: knitr
RoxygenNote: 5.0.1
NeedsCompilation: no
Packaged: 2016-04-27 10:47:14 UTC; adevries
Author: Andrie de Vries [aut, cre],
  Brian D. Ripley [aut] (author of package tree)
Maintainer: Andrie de Vries <apdevries@gmail.com>
Repository: CRAN
Date/Publication: 2016-04-27 18:28:33
Built: R 3.3.2; ; 2017-11-13 08:16:55 UTC; windows

Package: ggdendro
Version: 0.2.0
Title: Create Dendrograms and Tree Diagrams Using 'ggplot2'
Description: This is a set of tools for dendrograms and
    tree plots using 'ggplot2'.  The 'ggplot2' philosophy is to
    clearly separate data from the presentation.
    Unfortunately the plot method for dendrograms plots
    directly to a plot device without exposing the data.
    The 'ggdendro' package resolves this by making available
    functions that extract the dendrogram plot data. The package
    provides implementations for 'tree', 'rpart', as well as diana and agnes
    (from 'cluster') diagrams.
Authors@R: c(person("Andrie", "de Vries", role=c("aut", "cre"),
    email="apdevries@gmail.com"), person(c("Brian", "D."), "Ripley", role =
    c("aut"), comment = "author of package tree"))
License: GPL-2 | GPL-3
LazyLoad: true
ByteCompile: true
URL: https://andrie.github.io/ggdendro/
BugReports: https://github.com/andrie/ggdendro/issues
Depends: R(>= 3.5)
Imports: MASS, ggplot2(>= 0.9.2)
Suggests: rpart (>= 4.0-0), tree, testthat, knitr, cluster, scales,
        spelling, rmarkdown, covr
VignetteBuilder: knitr
RoxygenNote: 7.3.1
Language: en-US
Encoding: UTF-8
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-02-18 21:50:45 UTC; apdev
Author: Andrie de Vries [aut, cre],
  Brian D. Ripley [aut] (author of package tree)
Maintainer: Andrie de Vries <apdevries@gmail.com>
Repository: CRAN
Date/Publication: 2024-02-23 12:40:02 UTC
Built: R 4.4.0; ; 2024-05-06 07:07:14 UTC; unix

### Demonstrate tree

if (require(tree)) {
  require(ggplot2)
  require(MASS)
  data(cpus, package = "MASS")
  cpus.ltr <- tree(log10(perf) ~ syct + mmin + mmax + cach + chmin + chmax, 
                   data = cpus)
  tree_data <- dendro_data(cpus.ltr)
  ggplot(segment(tree_data)) +
    geom_segment(aes(x = x, y = y, xend = xend, yend = yend, linewidth = n),
      colour = "lightblue"
    ) +
    scale_size("n") +
    geom_text(
      data = label(tree_data),
      aes(x = x, y = y, label = label), vjust = -0.5, size = 4
    ) +
    geom_text(
      data = leaf_label(tree_data),
      aes(x = x, y = y, label = label), vjust = 0.5, size = 3
    ) +
    theme_dendro()
}

### Demonstrate rpart

if (require(rpart)) {
  require(ggplot2)
  fit <- rpart(Kyphosis ~ Age + Number + Start, method = "class", 
               data = kyphosis)
  fitr <- dendro_data(fit)
  ggplot() +
    geom_segment(data = fitr$segments, 
                 aes(x = x, y = y, xend = xend, yend = yend)
    ) +
    geom_text(data = fitr$labels, aes(x = x, y = y, label = label)) +
    geom_text(data = fitr$leaf_labels, aes(x = x, y = y, label = label)) +
    theme_dendro()
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----init---------------------------------------------------------------------
library(ggplot2)
library(ggdendro)

## ----dendrogram---------------------------------------------------------------
hc <- hclust(dist(USArrests), "ave")
ggdendrogram(hc, rotate = FALSE, size = 2)

## ----dendro1------------------------------------------------------------------
model <- hclust(dist(USArrests), "ave")
dhc <- as.dendrogram(model)
# Rectangular lines
ddata <- dendro_data(dhc, type = "rectangle")
p <- ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0))
p

## ----dendro-2-----------------------------------------------------------------
p + 
  coord_flip() + 
  theme_dendro()

## ----dendro-3-----------------------------------------------------------------
ddata <- dendro_data(dhc, type = "triangle")
ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0)) +
  theme_dendro()

## ----tree---------------------------------------------------------------------
if(require(tree)){
  data(cpus, package = "MASS")
  model <- tree(log10(perf) ~ syct + mmin + mmax + cach + chmin + chmax, 
                data = cpus)
  tree_data <- dendro_data(model)
  ggplot(segment(tree_data)) +
    geom_segment(aes(x = x, y = y, xend = xend, yend = yend, size = n), 
                 colour = "blue", alpha = 0.5) +
    scale_size("n") +
    geom_text(data = label(tree_data), 
              aes(x = x, y = y, label = label), vjust = -0.5, size = 3) +
    geom_text(data = leaf_label(tree_data), 
              aes(x = x, y = y, label = label), vjust = 0.5, size = 2) +
    theme_dendro()
}

## ----rpart--------------------------------------------------------------------
if(require(rpart)){
  model <- rpart(Kyphosis ~ Age + Number + Start, 
                 method = "class", data = kyphosis)
  ddata <- dendro_data(model)
  ggplot() + 
    geom_segment(data = ddata$segments, 
                 aes(x = x, y = y, xend = xend, yend = yend)) + 
    geom_text(data = ddata$labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 0) +
    geom_text(data = ddata$leaf_labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 1) +
    theme_dendro()
}

## ----twins--------------------------------------------------------------------
if(require(cluster)){
  model <- agnes(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
  
  model <- diana(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
}

### Demonstrate the twins of agnes and diana, from package cluster

if(require(cluster)){
  model <- agnes(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
}


if(require(cluster)){
  model <- diana(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
}

### Demonstrate ggdendrogram

library(ggplot2)
hc <- hclust(dist(USArrests), "ave")

# Demonstrate plotting directly from object class hclust
p <- ggdendrogram(hc, rotate=FALSE)
print(p)
ggdendrogram(hc, rotate=TRUE)

# demonstrate converting hclust to dendro using dendro_data first
hcdata <- dendro_data(hc)
ggdendrogram(hcdata, rotate=TRUE, size=2) + labs(title="Dendrogram in ggplot2")

require(ggplot2)

### Demonstrate dendro_data.dendrogram

model <- hclust(dist(USArrests), "ave")
dendro <- as.dendrogram(model)

# Rectangular lines
ddata <- dendro_data(dendro, type="rectangle")
ggplot(segment(ddata)) + 
  geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) + 
  coord_flip() + 
  scale_y_reverse(expand=c(0.2, 0)) + 
  theme_dendro()

# Triangular lines
ddata <- dendro_data(dendro, type="triangle")
ggplot(segment(ddata)) + 
  geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) + 
  theme_dendro()

# Demonstrate dendro_data.hclust

require(ggplot2)
hc <- hclust(dist(USArrests), "ave")

# Rectangular lines
hcdata <- dendro_data(hc, type="rectangle")
ggplot(segment(hcdata)) + 
  geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) + 
  coord_flip() + 
  scale_y_reverse(expand=c(0.2, 0)) + 
  theme_dendro()

# Triangular lines
hcdata <- dendro_data(hc, type="triangle")
ggplot(segment(hcdata)) + 
  geom_segment(aes(x=x, y=y, xend=xend, yend=yend)) +
  theme_dendro()

### Demonstrate tree

if(require(tree)){
  require(ggplot2)
  require(MASS)
  data(cpus, package="MASS")
  cpus.ltr <- tree(log10(perf) ~ syct+mmin+mmax+cach+chmin+chmax, cpus)
  tree_data <- dendro_data(cpus.ltr)
  ggplot(segment(tree_data)) +
    geom_segment(aes(x=x, y=y, xend=xend, yend=yend, size=n), 
                 colour="lightblue") +
    scale_size("n") +
    geom_text(data=label(tree_data), 
              aes(x=x, y=y, label=label), vjust=-0.5, size=4) +
    geom_text(data=leaf_label(tree_data), 
              aes(x=x, y=y, label=label), vjust=0.5, size=3) +
    theme_dendro()
}

## ----init----------------------------------------------------------------
library(ggplot2)
library(ggdendro)

## ----dendrogram----------------------------------------------------------
hc <- hclust(dist(USArrests), "ave")
ggdendrogram(hc, rotate = FALSE, size = 2)

## ----dendro1-------------------------------------------------------------
model <- hclust(dist(USArrests), "ave")
dhc <- as.dendrogram(model)
# Rectangular lines
ddata <- dendro_data(dhc, type = "rectangle")
p <- ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0))
p

## ----dendro-2------------------------------------------------------------
p + 
  coord_flip() + 
  theme_dendro()

## ----dendro-3------------------------------------------------------------
ddata <- dendro_data(dhc, type = "triangle")
ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0)) +
  theme_dendro()

## ----tree----------------------------------------------------------------
if(require(tree)){
  data(cpus, package = "MASS")
  model <- tree(log10(perf) ~ syct + mmin + mmax + cach + chmin + chmax, 
                data = cpus)
  tree_data <- dendro_data(model)
  ggplot(segment(tree_data)) +
    geom_segment(aes(x = x, y = y, xend = xend, yend = yend, size = n), 
                 colour = "blue", alpha = 0.5) +
    scale_size("n") +
    geom_text(data = label(tree_data), 
              aes(x = x, y = y, label = label), vjust = -0.5, size = 3) +
    geom_text(data = leaf_label(tree_data), 
              aes(x = x, y = y, label = label), vjust = 0.5, size = 2) +
    theme_dendro()
}

## ----rpart---------------------------------------------------------------
if(require(rpart)){
  model <- rpart(Kyphosis ~ Age + Number + Start, 
                 method = "class", data = kyphosis)
  ddata <- dendro_data(model)
  ggplot() + 
    geom_segment(data = ddata$segments, 
                 aes(x = x, y = y, xend = xend, yend = yend)) + 
    geom_text(data = ddata$labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 0) +
    geom_text(data = ddata$leaf_labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 1) +
    theme_dendro()
}

## ----twins---------------------------------------------------------------
if(require(cluster)){
  model <- agnes(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
  
  model <- diana(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
}

### Demionstrate rpart

if(require(rpart)){
  require(ggplot2)
  fit <- rpart(Kyphosis ~ Age + Number + Start, method="class", data=kyphosis)
  fitr <- dendro_data(fit)
  ggplot() + 
    geom_segment(data=fitr$segments, aes(x=x, y=y, xend=xend, yend=yend)) + 
    geom_text(data=fitr$labels, aes(x=x, y=y, label=label)) +
    geom_text(data=fitr$leaf_labels, aes(x=x, y=y, label=label)) +
    theme_dendro()
}

test_that("dendrogram plots", {
  skip_if_not_installed("ggplot2")
  require(ggplot2, quietly = TRUE)
  hc <- hclust(dist(USArrests), "ave")
  hcdata <- dendro_data(hc, type = "rectangle")
  p <- ggplot() +
    geom_segment(data = segment(hcdata), aes(x = x0, y = y0, xend = x1, yend = y1)) +
    geom_text(data = label(hcdata), aes(x = x, y = y, label = text)) +
    coord_flip() +
    scale_y_reverse(expand = c(0.2, 0))
  expect_s3_class(p, "ggplot")
})

test_that("large dendogram completes in reasonable time", {

  skip_on_cran()
  
  # find data file location
  file_location <- c(
    "tests/testthat/data/node_overflow_data.rds", "data/node_overflow_data.rds"
  )
  fl <- file_location[file.exists(file_location)]
  node_overflow_data <- readRDS(fl)
  
  # run hclust
  dhc <- hclust(dist(node_overflow_data), method = "average")
  
  # start ggdendro tests
  elapsed_time <- system.time({
    dhd <- dendro_data(dhc, type = "rectangle")
  })[[3]]
  
  
  # performance expectation: complete in less than 4 seconds
  expect_lt(elapsed_time, 10)
  
  expect_s3_class(dhd, "dendro")
  p2 <- ggdendrogram(dhd, type = "rectangle")

  expect_s3_class(p2, "ggplot")
})

test_that("data_tree() returns the correct classes", {
  if (!require("rpart", quietly = TRUE)) skip("package rpart not available")

  fit <- rpart(Kyphosis ~ Age + Number + Start, method = "class", data = kyphosis)
  tdata <- dendro_data(fit)
  expect_s3_class(tdata, "dendro")
  expect_s3_class(segment(tdata), "data.frame")
  expect_s3_class(label(tdata), "data.frame")
  expect_s3_class(leaf_label(tdata), "data.frame")
})

# Test functionality using testthat library
#
# Author: Andrie
#------------------------------------------------------------------------------


test_that("data_dendrogram() returns a correct classes", {
  hc <- hclust(dist(USArrests), "ave")
  dhc <- as.dendrogram(hc)

  expect_s3_class(dendro_data(dhc, type = "rectangle"), "dendro")

  ddata <- dendro_data(dhc, type = "rectangle")
  expect_s3_class(ddata$segments, "data.frame")
  expect_s3_class(ddata$labels, "data.frame")
  expect_equal(nrow(ddata$segments), 196)

  ddata <- dendro_data(dhc, type = "triangle")
  expect_s3_class(ddata$segments, "data.frame")
  expect_s3_class(ddata$labels, "data.frame")
  expect_equal(nrow(ddata$segments), 98)
})

#------------------------------------------------------------------------------

test_that("undefined model type throws error", {
  expect_error(dendro_data(USArrests))
})

test_that("data_hclust() returns the correct classes", {
  hc <- hclust(dist(USArrests), "ave")

  expect_s3_class(dendro_data(hc, type = "rectangle"), "dendro")

  ddata <- dendro_data(hc, type = "rectangle")
  expect_s3_class(segment(ddata), "data.frame")
  expect_s3_class(label(ddata), "data.frame")
  expect_equal(nrow(segment(ddata)), 196)
})

test_that("data_tree() returns the correct classes", {
  skip_if_not_installed("tree")

  data(cpus, package = "MASS")
  cpus.ltr <- tree::tree(log10(perf) ~ syct + mmin + mmax + cach + chmin + chmax, data = cpus)

  expect_s3_class(dendro_data(cpus.ltr), "dendro")
  tdata <- dendro_data(cpus.ltr)
  expect_s3_class(segment(tdata), "data.frame")
  expect_s3_class(label(tdata), "data.frame")
  expect_s3_class(leaf_label(tdata), "data.frame")
})

test_that("ggdendrogram plots and accepts ... parameters", {
  require(ggplot2)
  hc <- hclust(dist(USArrests), "ave")
  p1 <- ggdendrogram(hc)
  expect_s3_class(p1, "ggplot")
  p2 <- ggdendrogram(hc, size = 2)
  expect_s3_class(p2, "ggplot")
})

---
title: "Modifying ggdendogram output"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Modifying ggdendogram output}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```


If you use `ggdendrogram()` to create your plot, the resulting object is a `ggplot`. You have full control over this using any function available in `ggplot`.

First create an example dataset.

```{r setup}
library(ggdendro)
library(ggplot2)
hc <- hclust(dist(USArrests), "ave")
```


Plot the default `ggdendrogram()` output:


```{r example-default}
ggdendrogram(hc, rotate = FALSE, size = 2)
```

Use a different theme:


```{r example-1}
ggdendrogram(hc, rotate = FALSE, size = 2) +
  theme_bw()
```

Or modify just one element, for example add a y-axis.


```{r example-2}
ggdendrogram(hc, rotate = FALSE, size = 2) +
  theme( axis.line.y = element_line() )
```

In summary, `ggdendrogram()` is a convenience function that creates a `ggplot`.  Once you have this plot, you can modify the plot using tools that you are familiar with.

% \VignetteEngine{knitr::knitr}
% \VignetteIndexEntry{Create Dendrograms and Tree Diagrams using 'ggplot2'}
% \VignettePackage{ggdendro}


# Using the `ggdendro` package to plot dendrograms

The `ggdendro` package makes it easy to extract dendrogram and tree diagrams into a list of data frames.  You can then use this list to create these types of plots using the `ggplot2` package

## Introduction

The `ggdendro` package provides a general framework to extract the plot data for dendrograms and tree diagrams.

It does this by providing generic function `dendro_data()` that extracts the appropriate segment and label data, returning the data as a list of data frames.  

You can access these data frames using three accessor functions:

- `segment()`
- `label()`
- `leaf_label()`

The package also provides two convenient wrapper functions:


- `ggdendrogram()` is a wrapper around `ggplot()` to create a dendrogram using a single line of code.  The resulting object is of class `ggplot`, so can be manipulated using the `ggplot2` tools.
- `theme_dendro()` is a `ggplot2` theme with a blank canvas, i.e. no axes, axis labels or tick marks.

The `ggplot2` package doesn't get loaded automatically, so remember to load it first: 

```{r init}
library(ggplot2)
library(ggdendro)
```

## Using the `ggdendrogram()` wrapper

The `ggdendro` package extracts the plot data from dendrogram objects.  Sometimes it is useful to have fine-grained control over the plot.  Other times it might be more convenient to have a simple wrapper around `ggplot()` to produce a dendrogram with a small amount of code.

The function `ggdendrogram()` provides such a wrapper to produce a plot with a single line of code.  It provides a few options for controlling the display of line segments, labels and plot rotation (rotated by 90 degrees or not).  

```{r dendrogram}
hc <- hclust(dist(USArrests), "ave")
ggdendrogram(hc, rotate = FALSE, size = 2)
```


The next section shows how to take full control over the data extraction and subsequent plotting.

## Extracting the dendrogram plot data using `dendro_data()`

The `hclust()` and `dendrogram()` functions in R makes it easy to plot the results of hierarchical cluster analysis and other dendrograms in R.  However, it is hard to extract the data from this analysis to customise these plots, since the `plot()` functions for both these classes prints directly without the option of returning the plot data.  

```{r dendro1}
model <- hclust(dist(USArrests), "ave")
dhc <- as.dendrogram(model)
# Rectangular lines
ddata <- dendro_data(dhc, type = "rectangle")
p <- ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0))
p
```



Of course, using `ggplot2` to create the dendrogram means one has full control over the appearance of the plot.  For example, here is the same data, but this time plotted horizontally with a clean background.  In `ggplot2` this means
passing a number of options to `theme`.  The `ggdendro` packages exports a function, `theme_dendro()` that wraps these options into a convenient function.

```{r dendro-2}
p + 
  coord_flip() + 
  theme_dendro()
```


You can also draw dendrograms with triangular line segments (instead of rectangular segments).  For example:

```{r dendro-3}
ddata <- dendro_data(dhc, type = "triangle")
ggplot(segment(ddata)) + 
  geom_segment(aes(x = x, y = y, xend = xend, yend = yend)) + 
  coord_flip() + 
  scale_y_reverse(expand = c(0.2, 0)) +
  theme_dendro()
```



## Regression tree diagrams

The `tree()` function in package `tree` creates tree diagrams.  To extract the plot data for these diagrams using `ggdendro`, you use the the same idiom as for plotting dendrograms: 

```{r tree}
if(require(tree)){
  data(cpus, package = "MASS")
  model <- tree(log10(perf) ~ syct + mmin + mmax + cach + chmin + chmax, 
                data = cpus)
  tree_data <- dendro_data(model)
  ggplot(segment(tree_data)) +
    geom_segment(aes(x = x, y = y, xend = xend, yend = yend, size = n), 
                 colour = "blue", alpha = 0.5) +
    scale_size("n") +
    geom_text(data = label(tree_data), 
              aes(x = x, y = y, label = label), vjust = -0.5, size = 3) +
    geom_text(data = leaf_label(tree_data), 
              aes(x = x, y = y, label = label), vjust = 0.5, size = 2) +
    theme_dendro()
}
```



## Classification tree diagrams

The `rpart()` function in package `rpart` creates classification diagrams.  To extract the plot data for these diagrams using `ggdendro` follows the same basic pattern as dendrograms: 

```{r rpart}
if(require(rpart)){
  model <- rpart(Kyphosis ~ Age + Number + Start, 
                 method = "class", data = kyphosis)
  ddata <- dendro_data(model)
  ggplot() + 
    geom_segment(data = ddata$segments, 
                 aes(x = x, y = y, xend = xend, yend = yend)) + 
    geom_text(data = ddata$labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 0) +
    geom_text(data = ddata$leaf_labels, 
              aes(x = x, y = y, label = label), size = 3, vjust = 1) +
    theme_dendro()
}
```


## Twins diagrams: agnes and diana

The `clusters` package allows you to draw agnes and diana diagrams.

```{r twins}
if(require(cluster)){
  model <- agnes(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
  
  model <- diana(votes.repub, metric = "manhattan", stand = TRUE)
  dg <- as.dendrogram(model)
  ggdendrogram(dg)
}

```


## Conclusion

The `ggdendro` package makes it easy to extract the line segment and label data from `hclust`, `dendrogram` and `tree` objects.
